## nohang 0.1

=== Makefile ===
#
PREFIX = /

all:
	@ echo "Nothing to compile. Use: make install, make uninstall, make systemd"

install:
	install -d $(DESTDIR)/$(PREFIX)/usr/sbin
	install -m0755 ./nohang $(DESTDIR)/$(PREFIX)/usr/sbin/nohang
	
	install -d $(DESTDIR)/$(PREFIX)/usr/sbin
	install -m0755 ./nohang_notify_low_mem $(DESTDIR)/$(PREFIX)/usr/sbin/nohang_notify_low_mem
	
	install -d $(DESTDIR)/$(PREFIX)/etc/nohang
	install -m0644 ./nohang.conf $(DESTDIR)/$(PREFIX)/etc/nohang
	install -m0644 ./nohang.conf.backup $(DESTDIR)/$(PREFIX)/etc/nohang
	
	install -d $(DESTDIR)/$(PREFIX)/usr/share/man/man1
	gzip -k -c nohang.1 > $(DESTDIR)/$(PREFIX)/usr/share/man/man1/nohang.1.gz
	
	install -d $(DESTDIR)/$(PREFIX)/lib/systemd/system
	install -m0644 ./nohang.service $(DESTDIR)/$(PREFIX)/lib/systemd/system/nohang.service
	
	
uninstall:
	# 'make uninstall' must not fail with error if systemctl is unavailable or returns error
	systemctl disable nohang.service || true
	rm -fv $(PREFIX)/usr/sbin/nohang
	rm -fv $(PREFIX)/usr/sbin/nohang_notify_low_mem
	rm -fv $(PREFIX)/usr/share/man/man1/nohang.1.gz
	rm -fv $(PREFIX)/lib/systemd/system/nohang.service
	rm -fvr $(PREFIX)/etc/nohang/
	
systemd:
	systemctl daemon-reload
	systemctl enable nohang.service
	systemctl restart nohang

=== debian/changelog ===
nohang (0.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Thu, 04 Jun 2020 21:45:35 -0400

nohang (0.1-1) unstable; urgency=medium

  * Initial Release

 -- Yangfl <mmyangfl@gmail.com>  Sat, 04 Apr 2020 13:37:56 +0800

=== debian/control ===
Source: nohang
Maintainer: Yangfl <mmyangfl@gmail.com>
Section: admin
Priority: optional
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 python3,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/yangfl-guest/nohang
Vcs-Git: https://salsa.debian.org/yangfl-guest/nohang.git
Homepage: https://github.com/hakavlad/nohang

Package: nohang
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Suggests:
 libnotify-bin,
 sudo,
Description: sophisticated low memory handler for Linux
 nohang is a highly configurable daemon for Linux which is able to correctly
 prevent out of memory (OOM) and keep system responsiveness in low memory
 conditions.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


%:
	dh $@ --with python3

## nohang 0.2.0

=== Makefile ===
DESTDIR ?=
PREFIX ?=         /usr/local
SYSCONFDIR ?=     /usr/local/etc
SYSTEMDUNITDIR ?= /usr/local/lib/systemd/system

BINDIR ?=  $(PREFIX)/bin
SBINDIR ?= $(PREFIX)/sbin
DATADIR ?= $(PREFIX)/share
DOCDIR ?=  $(DATADIR)/doc/nohang
MANDIR ?=  $(DATADIR)/man

PANDOC := $(shell command -v pandoc 2> /dev/null)

all:
	@ echo "Use: make install, make install-openrc, make uninstall"

update-manpages:

ifdef PANDOC
	pandoc docs/nohang.manpage.md -s -t man > man/nohang.8
	pandoc docs/oom-sort.manpage.md -s -t man > man/oom-sort.1
	pandoc docs/psi2log.manpage.md -s -t man > man/psi2log.1
	pandoc docs/psi-top.manpage.md -s -t man > man/psi-top.1
else
	@echo "pandoc is not installed, skipping manpages generation"
endif

base:
	install -p -d $(DESTDIR)$(SBINDIR)
	install -p -m0755 src/nohang $(DESTDIR)$(SBINDIR)/nohang

	install -p -d $(DESTDIR)$(BINDIR)
	install -p -m0755 src/oom-sort $(DESTDIR)$(BINDIR)/oom-sort
	install -p -m0755 src/psi-top $(DESTDIR)$(BINDIR)/psi-top
	install -p -m0755 src/psi2log $(DESTDIR)$(BINDIR)/psi2log

	install -p -d $(DESTDIR)$(SYSCONFDIR)/nohang

	sed "s|:TARGET_DATADIR:|$(DATADIR)|" \
		conf/nohang/nohang.conf.in > nohang.conf

	sed "s|:TARGET_DATADIR:|$(DATADIR)|" \
		conf/nohang/nohang-desktop.conf.in > nohang-desktop.conf

	install -p -m0644 nohang.conf $(DESTDIR)$(SYSCONFDIR)/nohang/nohang.conf
	install -p -m0644 nohang-desktop.conf $(DESTDIR)$(SYSCONFDIR)/nohang/nohang-desktop.conf

	install -p -d $(DESTDIR)$(DATADIR)/nohang

	install -p -m0644 nohang.conf $(DESTDIR)$(DATADIR)/nohang/nohang.conf
	install -p -m0644 nohang-desktop.conf $(DESTDIR)$(DATADIR)/nohang/nohang-desktop.conf

	-git describe --tags --long --dirty > version
	install -p -m0644 version $(DESTDIR)$(DATADIR)/nohang/version

	rm -fv nohang.conf
	rm -fv nohang-desktop.conf
	rm -fv version

	install -p -d $(DESTDIR)/etc/logrotate.d
	install -p -m0644 conf/logrotate.d/nohang $(DESTDIR)/etc/logrotate.d/nohang

	install -p -d $(DESTDIR)$(MANDIR)/man1
	gzip -9cn man/oom-sort.1 > $(DESTDIR)$(MANDIR)/man1/oom-sort.1.gz
	gzip -9cn man/psi-top.1 > $(DESTDIR)$(MANDIR)/man1/psi-top.1.gz
	gzip -9cn man/psi2log.1 > $(DESTDIR)$(MANDIR)/man1/psi2log.1.gz

	install -p -d $(DESTDIR)$(MANDIR)/man8

	sed "s|:SYSCONFDIR:|$(SYSCONFDIR)|g; s|:DATADIR:|$(DATADIR)|g" \
		man/nohang.8 > nohang.8

	gzip -9cn nohang.8 > $(DESTDIR)$(MANDIR)/man8/nohang.8.gz
	rm -fv nohang.8

	install -p -d $(DESTDIR)$(DOCDIR)
	install -p -m0644 README.md $(DESTDIR)$(DOCDIR)/README.md
	install -p -m0644 CHANGELOG.md $(DESTDIR)$(DOCDIR)/CHANGELOG.md

units:
	install -p -d $(DESTDIR)$(SYSTEMDUNITDIR)

	sed "s|:TARGET_SBINDIR:|$(SBINDIR)|; s|:TARGET_SYSCONFDIR:|$(SYSCONFDIR)|" \
		systemd/nohang.service.in > nohang.service

	sed "s|:TARGET_SBINDIR:|$(SBINDIR)|; s|:TARGET_SYSCONFDIR:|$(SYSCONFDIR)|" \
		systemd/nohang-desktop.service.in > nohang-desktop.service

	install -p -m0644 nohang.service $(DESTDIR)$(SYSTEMDUNITDIR)/nohang.service
	install -p -m0644 nohang-desktop.service $(DESTDIR)$(SYSTEMDUNITDIR)/nohang-desktop.service

	rm -fv nohang.service
	rm -fv nohang-desktop.service

chcon:
	chcon -t systemd_unit_file_t $(DESTDIR)$(SYSTEMDUNITDIR)/nohang.service || :
	chcon -t systemd_unit_file_t $(DESTDIR)$(SYSTEMDUNITDIR)/nohang-desktop.service || :

daemon-reload:
	systemctl daemon-reload || :

build_deb: base units

reinstall-deb:
	set -v
	deb/build.sh
	sudo apt install --reinstall ./deb/package.deb

install: base units chcon daemon-reload
	# This is fine.

install-openrc: base
	install -p -d $(DESTDIR)$(SYSCONFDIR)/init.d
	sed "s|:TARGET_SBINDIR:|$(SBINDIR)|; s|:TARGET_SYSCONFDIR:|$(SYSCONFDIR)|" \
		openrc/nohang.in > openrc/nohang
	sed "s|:TARGET_SBINDIR:|$(SBINDIR)|; s|:TARGET_SYSCONFDIR:|$(SYSCONFDIR)|" \
		openrc/nohang-desktop.in > openrc/nohang-desktop
	install -p -m0775 openrc/nohang $(DESTDIR)$(SYSCONFDIR)/init.d/nohang
	install -p -m0775 openrc/nohang-desktop $(DESTDIR)$(SYSCONFDIR)/init.d/nohang-desktop
	rm -fv openrc/nohang
	rm -fv openrc/nohang-desktop

uninstall-base:
	rm -fv $(DESTDIR)$(SBINDIR)/nohang
	rm -fv $(DESTDIR)$(BINDIR)/oom-sort
	rm -fv $(DESTDIR)$(BINDIR)/psi-top
	rm -fv $(DESTDIR)$(BINDIR)/psi2log

	rm -fv $(DESTDIR)$(MANDIR)/man1/oom-sort.1.gz
	rm -fv $(DESTDIR)$(MANDIR)/man1/psi-top.1.gz
	rm -fv $(DESTDIR)$(MANDIR)/man1/psi2log.1.gz

	rm -fv $(DESTDIR)$(MANDIR)/man8/nohang.8.gz

	rm -fvr $(DESTDIR)$/etc/logrotate.d/nohang
	rm -fvr $(DESTDIR)$(DOCDIR)/
	rm -fvr $(DESTDIR)/var/log/nohang/
	rm -fvr $(DESTDIR)$(DATADIR)/nohang/
	rm -fvr $(DESTDIR)$(SYSCONFDIR)/nohang/

uninstall-units:
	systemctl stop nohang.service || :
	systemctl stop nohang-desktop.service || :
	systemctl disable nohang.service || :
	systemctl disable nohang-desktop.service || :

	rm -fv $(DESTDIR)$(SYSTEMDUNITDIR)/nohang.service
	rm -fv $(DESTDIR)$(SYSTEMDUNITDIR)/nohang-desktop.service

uninstall-openrc:
	rc-service nohang-desktop stop || :
	rc-service nohang stop || :

	rm -fv $(DESTDIR)$(SYSCONFDIR)/init.d/nohang
	rm -fv $(DESTDIR)$(SYSCONFDIR)/init.d/nohang-desktop

uninstall: uninstall-base uninstall-units daemon-reload uninstall-openrc

=== debian/changelog ===
nohang (0.2.0-3) unstable; urgency=medium

  * Make the use of notify-send / sudo conditional (Closes: #1088276)
  * Recommend libnotify-bin / sudo
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Fri, 07 Mar 2025 22:27:01 +0800

nohang (0.2.0-2) unstable; urgency=medium

  * Ack NMU.
  * Bump standards version to 4.7.0.
  * Apply upstream fix for DeprecationWarning. (LP: #2049206)
  * d/rules: fix path. (Closes: #1073732)

 -- Alex Myczko <tar@debian.org>  Mon, 01 Jul 2024 09:12:42 +0000

nohang (0.2.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to rebuild with debhelper 13.10.

 -- Michael Biebl <biebl@debian.org>  Sat, 15 Oct 2022 12:28:45 +0200

nohang (0.2.0-1) unstable; urgency=medium

  * New upstream version (Closes: #979207)
    - Fix SyntaxWarning (Closes: #976005)

  [ Gürkan Myczko ]
  * Bump debhelper mode to 13.
  * d/copyright: update years.
  * d/control: add myself as co-maintainer.
  * d/lintian-overrides: dropped.

 -- Yangfl <mmyangfl@gmail.com>  Mon, 04 Jan 2021 17:01:33 +0800

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: nohang
 Maintainer: Yangfl <mmyangfl@gmail.com>
+Uploaders: Alex Myczko <tar@debian.org>
 Section: admin
 Priority: optional
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-python,
  python3,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/nohang
 Vcs-Git: https://salsa.debian.org/yangfl-guest/nohang.git
 Homepage: https://github.com/hakavlad/nohang
@@ -19,7 +20,7 @@
  ${python3:Depends},
 Pre-Depends:
  ${misc:Pre-Depends},
-Suggests:
+Recommends:
  libnotify-bin,
  sudo,
 Description: sophisticated low memory handler for Linux

=== debian/rules ===
--- 
+++ 
@@ -4,3 +4,6 @@
 
 %:
 	dh $@ --with python3
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=/usr SYSCONFDIR=/etc SYSTEMDUNITDIR=/usr/lib/systemd/system

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%nohang-$1.tar.gz%" \
   https://github.com/hakavlad/nohang/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## nohang 0.3.0

=== debian/changelog ===
nohang (0.3.0-3) unstable; urgency=medium

  * d/nohang-desktop.service: added to d/examples.
  * d/init: renamed to init.disabled.
  * d/README.Debian: added.

 -- Alex Myczko <tar@debian.org>  Sun, 18 Jan 2026 10:06:48 +0100

nohang (0.3.0-2) unstable; urgency=medium

  * d/version: added.
  * d/nohang.postrm: added.

 -- Alex Myczko <tar@debian.org>  Fri, 16 Jan 2026 18:59:01 +0100

nohang (0.3.0-1) unstable; urgency=medium

  * New upstream version.
  * d/control:
    - drop Rules-Requires-Root.
    - Depends/Build-Depends: add ucf.
  * d/watch: update to version 5.
  * d/copyright: bump years.
  * d/manpages: added.
  * d/docs: added.
  * d/clean: added.
  * d/nohang.service: added.
  * d/nohang.postinst: added.
  * d/nohang.dirs: added.

 -- Alex Myczko <tar@debian.org>  Sun, 11 Jan 2026 10:06:23 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  dh-python,
  python3,
-Rules-Requires-Root: no
+ ucf,
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/nohang
 Vcs-Git: https://salsa.debian.org/yangfl-guest/nohang.git
@@ -18,6 +18,7 @@
 Depends:
  ${misc:Depends},
  ${python3:Depends},
+ ucf,
 Pre-Depends:
  ${misc:Pre-Depends},
 Recommends:

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@ --with python3

override_dh_auto_configure:
	cp systemd/nohang.service.in systemd/nohang.service

override_dh_auto_install:
	@echo moo
#	dh_auto_install -- PREFIX=/usr SYSCONFDIR=/etc SYSTEMDUNITDIR=/usr/lib/systemd/system
